#!/bin/bash

# set the timezone to UTC
mv -f /etc/localtime /etc/localtime.bak
ln -s /usr/share/zoneinfo/UTC /etc/localtime

#create directories and files
mkdir /tmp/scap_validation_content
mkdir /tmp/scap_validation_content/unix_file
mkdir /tmp/scap_validation_content/unix_file/ne
mkdir /tmp/scap_validation_content/unix_file/e
chmod 777 /tmp/scap_validation_content/unix_file/e
chmod +t /tmp/scap_validation_content/unix_file/e
echo "This is 1.txt scap validation test file.">>/tmp/scap_validation_content/unix_file/e/1.txt
echo "This is 2.txt scap validation test file.">>/tmp/scap_validation_content/unix_file/e/2.txt
cp Skeleton.sh /tmp/scap_validation_content/unix_file/Skeleton.sh
cp Skeleton.sh /tmp/scap_validation_content/unix_file/e/Skeleton.sh
touch -a -t 201108011526.12 /tmp/scap_validation_content/unix_file/Skeleton.sh
touch -m -t 201108011439.31 /tmp/scap_validation_content/unix_file/Skeleton.sh
echo "This is Skeleton2.sh scap validation test file.">>/tmp/scap_validation_content/unix_file/e/Skeleton2.sh
echo "This is Skeleton3.sh scap validation test file.">>/tmp/scap_validation_content/unix_file/e/Skeleton3.sh
echo "This is a test file for the scap validation program.">/tmp/scap_validation_content/unix_file/e/abc.txt
#create testuser and scapvalidation group
groupadd -g 500 scapvalidation
useradd -g scapvalidation -u 5000 testuser
chown testuser:scapvalidation /tmp/scap_validation_content/unix_file/e/1.txt
chmod 777 /tmp/scap_validation_content/unix_file/e/1.txt
chmod a+s /tmp/scap_validation_content/unix_file/e/1.txt
chmod 77 /tmp/scap_validation_content/unix_file/e/Skeleton2.sh
#set extended attribute
setfattr -n user.testing -v "this is a test" /tmp/scap_validation_content/unix_file/e/Skeleton3.sh
setfacl -m g:scapvalidation:rx /tmp/scap_validation_content/unix_file/e/Skeleton3.sh
chmod 700 /tmp/scap_validation_content/unix_file/e/Skeleton3.sh

# Configuration for @behaviour attribute
if [ ! -d "/scapVal" ]; then
  mkdir /scapVal
fi
mkdir /scapVal/File-Test-Level2
mkdir /scapVal/File-Test-Level2/Level3-Folder010
mkdir /scapVal/File-Test-Level2/Level3-Folder020
mkdir /scapVal/File-Test-Level2/Level3-Folder030
mkdir /scapVal/File-Test-Level2/Level3-Folder040
mkdir /scapVal/File-Test-Level2/Level3-Folder050
mkdir /scapVal/File-Test-Level2/Level3-Folder010/Level4-Folder011
mkdir /scapVal/File-Test-Level2/Level3-Folder010/Level4-Folder011/Level5-Folder012

echo "This is a Level3-File scap validation test file.">>/scapVal/File-Test-Level2/Level3-Folder010/Level3-File010.txt
echo "This is a Level5-File 0121 test file for the scap validation program.">/scapVal/File-Test-Level2/Level3-Folder010/Level4-Folder011/Level5-Folder012/Level5-File0121.txt
echo "This is a Level5-File 0122 test file for the scap validation program.">/scapVal/File-Test-Level2/Level3-Folder010/Level4-Folder011/Level5-Folder012/Level5-File0122.log

mkdir /scapVal-Sym
mkdir /scapVal-Sym/File-Test-Level2-SymLinked
mkdir /scapVal-Sym/File-Test-Level2-SymLinked/Level3-SymLinked-Folder010
echo "This is a Level3-File test file for the scap validation program.">/scapVal-Sym/File-Test-Level2-SymLinked/Level3-SymLinked-Folder010/Level3-File.txt
mkdir /scapVal-Sym/File-Test-Level2-SymLinked/Level3-SymLinked-Folder010/Level4-Folder
echo "This is a Level4-File test file for the scap validation program.">/scapVal-Sym/File-Test-Level2-SymLinked/Level3-SymLinked-Folder010/Level4-Folder/Level4-File.txt

#              TARGET --> LinkName
#ln -s /path/to/original/ /path/to/linkName
ln -s /scapVal-Sym/File-Test-Level2-SymLinked/ /scapVal/File-Test-Level2/Level3-Folder040/this_is_a_symlink
echo "This is a Level2-File test file for the scap validation program.">/scapVal-Sym/File-Test-Level2-SymLinked/File-Test-Sym-Level2.txt
echo "This is a Level0-File test file for the scap validation program.">/File-Test-Level0.txt